//deklarace funkci z DLL knihovny a funkce pro pristup k funkcim vracejicim
// string (!!! unicodestring !!!)

//obsluha knihovnich funkci, ktere vraceji string je trochu slozitejsi,
//proto je zde potrebna funkce z knihovny importovana s postfixem Int
//a jeji pouziti je zapouzdreno zapouzdrena do funkci Get<jmeno_funkce>FromFll(...)


const MAX_STRING_RESULT_LENGTH=3000000; //maximalni delka vraceneho stringu
      ML_RECURSIVE_YES=true;
      ML_RECURSIVE_NO=false;
      ML_REWRITE_YES=true;
      ML_REWRITE_NO=false;
      ML_SHOWDEVICELIST_AUTO=false;
      ML_SHOWDEVICELIST_ALWAYS=true;
      ML_INIT_SHOWPROGRES_VALUE=12345;
var ML_MaxBufferSize:integer;
    ML_iShowProgress:integer;
//pokud knihovna neni registrovana v systemu, musi byt v adresari s programem GG
  //dela to problem i kdyz mam knihovnu prelozenou s predavanim funkci stdcall

procedure ML_SetBufferSize(nMax:integer);
begin
  if(nMax<300) then nMax:=300;
  ML_MaxBufferSize:=nMax;
end;
//funkce vracejici string, maji zde vlastni obsluhu ML_...Int(...)
//funkce ve skutecnosti vraci pocet znaku, ktere naplnila do bufferu
//jeho dostatecnou velikost musi zajistit volajici, a ten take musi
//pak velikost bufferu upravit na skutecnou velikost textu. Proto jsou tyto
//funkce zapouzdreny do funkci, ktere pak vraceji uz skutecny string
procedure ML_SetDeviceName(sName:unicodestring); external 'ML_SetDeviceName@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_GetErrorCode:integer; external 'ML_GetErrorCode@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_GetErrorMessageInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_GetErrorMessage@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_GetDllVersionInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_GetDllVersion@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
procedure ML_SetProgressBarInt(iShow:integer); external 'ML_SetProgressBar@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';

function ML_DevicesInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_Devices@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_FunctionalObjectsInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_FunctionalObjects@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_FunctionalObjectsIntW(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_FunctionalObjectsW@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_DeviceInfoInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_DeviceInfo@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_FunctionalCategoriesInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_FunctionalCategories@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_ContentTypesInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_ContentTypes@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_PropertiesInt(sPath,sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_Properties@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_DirInt(sPath,sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_Dir@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_SupportedCommandsInt(sBuffer:unicodestring; iMaxLen:integer):integer; external 'ML_SupportedCommands@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';

//funkce vracejici int (jako priznak uspesnosti), vlastni obsluhu tu nemaji
function ML_Exists(sPath:unicodestring):integer; external 'ML_Exists@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_GetFile(sSrc,sTrg:unicodestring; bOverwrite:boolean):integer; external 'ML_GetFile@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_PutFile(sSrcPath,sTrgDir:unicodestring; bOverwrite:boolean):integer; external 'ML_PutFile@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_DeleteFile(sSrc:unicodestring):integer; external 'ML_DeleteFile@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_RenameFile(sSrc,sTrg:unicodestring;bOverwrite:boolean):integer; external 'ML_RenameFile@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_MoveFile(sSrc,sTrg:unicodestring;bOverwrite:boolean):integer; external 'ML_MoveFile@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_MkDir(sPath:unicodestring;bRecursively:boolean):integer; external 'ML_MkDir@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_RmDir(sPath:unicodestring;bRecursively:boolean):integer; external 'ML_RmDir@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_PutDir(sSrcDir,sMask,sTrgDir:unicodestring; bRecursively,bOverwrite:boolean):integer; external 'ML_PutDir@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';
function ML_GetDir(sSrcDir,sMask,sTrgDir:unicodestring; bRecursively,bOverwrite:boolean):integer; external 'ML_GetDir@.\script\lib\MtpToolLib\MtpLib.dll cdecl delayload';

procedure TestLengthOutputFromDll(iLen:integer; sInfo:string);
begin
  if(iLen<ML_MaxBufferSize-1) then exit;
  ShowMessage(sInfo+CRLF+'WARN: returned string is too long!');
end;

procedure ML_SetProgressBar(iShow:integer);
begin
  ML_iShowProgress:=ML_INIT_SHOWPROGRES_VALUE+iShow;                 //uschovame hodnotu
  ML_SetProgressBarInt(iShow);
end;

function ML_GetErrorMessage:unicodestring;
var iLen:integer;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_GetErrorMessageInt(Result,ML_MaxBufferSize);
  SetLength(Result,iLen);
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
end;

function ML_GetDllVersion:unicodestring;
var iLen:integer;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_GetDllVersionInt(Result,ML_MaxBufferSize);
  SetLength(Result,iLen);
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
end;

function ML_Devices:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_DevicesInt(Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetDevicesFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetDevicesFromDll():');
end;

function ML_DeviceInfo:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_DeviceInfoInt(Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetDeviceInfoFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetDeviceInfoFromDll():');
end;

function ML_FunctionalObjects:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_FunctionalObjectsInt(Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetFunctionalObjectsFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetFunctionalObjectsFromDll():');
end;

//function ML_FunctionalObjects:unicodestring;
function ML_FunctionalObjectsW:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  ShowMessage('AAA');
  iLen:=ML_FunctionalObjectsIntW(Result,ML_MaxBufferSize);
  ShowMessage('BBB 1 ');
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  //ShowMessage('BBB 2');
  sErr:=ML_GetErrorMessage();
  //ShowMessage('BBB 3');
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  //ShowMessage('BBB 4');
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  //ShowMessage('BBB 5');
  if(sErr<>'') then ShowMessage('GetFunctionalObjectsWFromDll(): '+sErr);
  //ShowMessage('BBB 6');
  TestLengthOutputFromDll(iLen,'GetFunctionalObjectsWFromDll():');
  //ShowMessage('BBB 7');
end;

function ML_FunctionalCategories:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_FunctionalCategoriesInt(Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetFunctionalTypesFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetFunctionalTypesFromDll():');
end;

function ML_ContentTypes:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_ContentTypesInt(Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetTypesObjectsFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetTypesObjectsFromDll():');
end;

function ML_Properties(sPath:unicodestring):unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_PropertiesInt(sPath,Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetTypesObjectsFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetTypesObjectsFromDll():');
end;

function ML_Dir(sPath:unicodestring):unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_DirInt(sPath,Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetDirFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetDirFromDll():');
end;

function ML_SupportedCommands:unicodestring;
var iLen:integer;
    sErr:unicodestring;
begin
  if(ML_MaxBufferSize<300) then ML_SetBufferSize(MAX_STRING_RESULT_LENGTH);
  SetLength(Result,ML_MaxBufferSize);
  iLen:=ML_SupportedCommandsInt(Result,ML_MaxBufferSize);
  if(iLen>=0) then SetLength(Result,iLen)
  else SetLength(Result,0);
  sErr:=ML_GetErrorMessage();
  //prevod unixovych radku na Windowsi
  if(Pos(CRLF[1],Result)<1) then Result:=ReplaceString(Result,CRLF[2],CRLF);
  if(Pos(CRLF[1],sErr)<1) then sErr:=ReplaceString(sErr,CRLF[2],CRLF);
  if(sErr<>'') then ShowMessage('GetDirFromDll(): '+sErr);
  TestLengthOutputFromDll(iLen,'GetDirFromDll():');
end;
